#######Csereklyei & Stern: Global Energy Use: Decoupling or Convergence?  ########
#######40-YEAR MODEL########

#install.packages("spdep")
#install.packages("stargazer")
#install.packages("sandwich")
library(spdep)
library(stargazer)
library(sandwich)
library(lmtest)
dat<-read.csv("longenergy93_v4stata.csv")



####Reading in MATRICES######
#Choose only one of the normalised matrices. 

# Model 1- NORMALISED MATRIX, ROW STANDARDISED######
W<-read.csv("norm93a.csv")
Wl<-mat2listw(as.matrix(W))


# For the alternative model - NORMALISED MATRIX, Minimum Distance Neighbour Factor=1.4
W<-read.csv("nbMindist1.4.csv")
Wl<-mat2listw(as.matrix(W))


lmbase<-lm(gEP~gYP+dm_ypmeangYP, data=dat)
summary(lmbase)
coeftest(lmbase, vcov=vcovHAC(lmbase)) 
lagcol<-SpatialFiltering(gEP~1,~gYP+dm_ypmeangYP-1, data=dat, nb=Wl$neighbours, style="W", ExactEV=FALSE,tol=1)
lmlag<-lm(gEP~gYP+dm_ypmeangYP+fitted(lagcol), data=dat)
lmlag
coeftest(lmlag, vcov=vcovHAC(lmlag)) 
anova(lmbase,lmlag)
lm.morantest(lmlag,listw=Wl)


#####Model2######
lmbase2<-lm(gEP~gYP+dm_ypmeangYP+dm_ypmean, data=dat)
coeftest(lmbase2, vcov=vcovHAC(lmbase2)) 
lagcol2<-SpatialFiltering(gEP~1,~gYP+dm_ypmeangYP+dm_ypmean-1, data=dat, nb=Wl$neighbours, style="W", ExactEV=FALSE,tol=1)
lmlag2<-lm(gEP~gYP+dm_ypmeangYP+dm_ypmean+fitted(lagcol2), data=dat)
lmlag2
coeftest(lmlag2, vcov=vcovHAC(lmlag2))
anova(lmbase2,lmlag2)
lm.morantest(lmlag2,listw=Wl)



#####Model3######
lmbase3<-lm(gEP~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971, data=dat)
coefficients(lmbase3) 
coeftest(lmbase3, vcov=vcovHAC(lmbase3)) 
lagcol3<-SpatialFiltering(gEP~1,~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971-1, data=dat, nb=Wl$neighbours, style="W", ExactEV=FALSE,tol=1)
lmlag3<-lm(gEP~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971+fitted(lagcol3), data=dat)
lmlag3
coeftest(lmlag3, vcov=vcovHAC(lmlag3))
anova(lmbase3,lmlag3)
lm.morantest(lmlag3,listw=Wl)




#####Model4######
lmbase4<-lm(gEP~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971+dm_avpolity, data=dat)
coeftest(lmbase4, vcov=vcovHAC(lmbase4)) 
lagcol4<-SpatialFiltering(gEP~1,~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971+dm_avpolity-1, data=dat, nb=Wl$neighbours, style="W", ExactEV=FALSE,tol=1)
lmlag4<-lm(gEP~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971+dm_avpolity+fitted(lagcol4), data=dat)
lmlag4
coeftest(lmlag4, vcov=vcovHAC(lmlag4))
anova(lmbase4,lmlag4)
lm.morantest(lmlag4,listw=Wl)



#####Model8######
lmbase8<-lm(gEP~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971+dm_ffe+dm_avpolity, data=dat)
coeftest(lmbase8, vcov=vcovHAC(lmbase8))  
lagcol8<-SpatialFiltering(gEP~1,~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971+dm_ffe+dm_avpolity-1, data=dat, nb=Wl$neighbours, style="W", ExactEV=FALSE,tol=1)
lmlag8<-lm(gEP~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971+dm_ffe+dm_avpolity+fitted(lagcol8), data=dat)
lmlag8
coeftest(lmlag8, vcov=vcovHAC(lmlag8))
anova(lmbase8,lmlag8)
lm.morantest(lmlag8,listw=Wl)



#####Model9######
lmbase9<-lm(gEP~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971+dm_ffe+dm_avpolity+dm_h2o+dm_sumt+dm_wint+cpe, data=dat)
coeftest(lmbase9, vcov=vcovHAC(lmbase9))  
lagcol9<-SpatialFiltering(gEP~1,~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971+dm_ffe+dm_avpolity+dm_h2o+dm_sumt+dm_wint+cpe-1, data=dat, nb=Wl$neighbours, style="W", ExactEV=FALSE,tol=1)
lmlag9<-lm(gEP~gYP+dm_ypmeangYP+dm_ypmean+dm_ei1971+dm_ffe+dm_avpolity+dm_h2o+dm_sumt+dm_wint+cpe+fitted(lagcol9), data=dat)
lmlag9
coeftest(lmlag9, vcov=vcovHAC(lmlag9))
anova(lmbase9,lmlag9)
lm.morantest(lmlag9,listw=Wl)
#lmlag9$model




